#!/usr/bin/env python


"""This file is used to install the cli package."""


# standard library(ies)
import pathlib as pl
import typing

# 3rd party package(s)
import setuptools

# package module(s)
import clinterfacer as package


def read(path: typing.Union[str, pl.Path], encoding: str = 'utf-8') -> str:
    if isinstance(path, str):
        path = pl.Path(path)
    return path.read_text(encoding) if path.exists() else ''


metadata = {
    'name': package.__name__,
    'version': package.__version__,
    'author': package.__author__,
    'author_email': package.__email__,
    'maintainer': package.__maintainer__,
    'maintainer_email': package.__email__,
    'description': package.__description__,
    'long_description': read('./README.md'),
    'long_description_content_type': 'text/markdown',
    'url': package.__url__,
    'packages': setuptools.find_packages(),
    'include_package_data': True,
    'install_requires': [
    ],
    # 'entry_points': {
    #     'console_scripts': [
    #         f'{package.__name__} = {package.__name__}.__main__:main',
    #     ],
    # },
    'classifiers': [
        'Environment :: Console',
        'Programming Language :: Python :: 3.7',
        'Operating System :: OS Independent',
    ],
}
if __name__ == '__main__':
    setuptools.setup(**metadata)
